<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">

<xsl:output 
   method="xml" encoding="UTF-8" 
   media-type="text/xml" 
   doctype-public="-//W3C//DTD XHTML 1.1//EN" 
   doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"
   indent="yes" />

<!-- =========ROOT========= -->
<xsl:template match="/">
<xsl:element name="html">

  <xsl:attribute name="lang"
            namespace="http://www.w3.org/XML/1998/namespace">ja</xsl:attribute>
  <xsl:call-template name="head" />
<!-- =========Body========= -->
  <xsl:element name="body">
<!-- =========Navi========= -->
  <xsl:call-template name="navi" />
<!-- =========Entry========= -->
  <xsl:apply-templates select="daybookindex/items/item" />
  
<!-- =========Comment========= -->
<br />
<hr />
<br />
  <xsl:element name="dl"><xsl:element name="dt">
  <xsl:apply-templates select="daybookindex/comments" />
  </xsl:element></xsl:element>

<!-- =========Futter========= -->
<hr />
<xsl:element name="p">
    <xsl:element name="i">Powerd By
	<xsl:element name="a"><xsl:attribute name="href">/daybook/aboutmidoredaybook.html</xsl:attribute>MidoreDaybook
	</xsl:element></xsl:element>
</xsl:element>
<!-- Futter end -->

</xsl:element><!-- end of body -->
</xsl:element><!-- end of html -->
</xsl:template>

<!-- ================Templates Comment===================== -->
<xsl:template match="daybookindex/comments" >
	  <xsl:apply-templates select="item_comment" />
</xsl:template>

<xsl:template match="item_comment" >	
	<xsl:element name="dd">
		<xsl:element name="a"><xsl:attribute name="href"><xsl:value-of select="uri" /></xsl:attribute>
		Posted By:&#8220;
		<xsl:value-of select="name" disable-output-escaping="yes" />
		&#8221;&#8194;at&#8194;
		<xsl:value-of select="date" />
        </xsl:element>
		&#8194;&#8194;
		<xsl:value-of select="subject" disable-output-escaping="yes"/>
	</xsl:element>
</xsl:template>

<!-- ================Templates Entry===================== -->
<xsl:template match="daybookindex/items/item" >
<xsl:element name="dl">
  	<xsl:element name="dt"><xsl:element name="a"><xsl:attribute name="href">
	  <xsl:value-of select="uri" /></xsl:attribute>
      <xsl:value-of select="subject" disable-output-escaping="yes"/>
      </xsl:element></xsl:element>
<xsl:element name="dd">&#8194;<xsl:value-of select="date" /><xsl:value-of select="telop" /></xsl:element>

<xsl:apply-templates select="p" />

</xsl:element>
</xsl:template>

<!-- ================Templates p===================== -->
<xsl:template match="p">
	<xsl:element name="p"><xsl:value-of select="." disable-output-escaping="yes"/>...</xsl:element>
</xsl:template>

<!-- ================Templates Header===================== -->
<xsl:template name="head">
  <xsl:element name="head">
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <meta name="author" content="midore"/>
    <!-- meta name="date" -->
    <xsl:element name="meta">
      <xsl:attribute name="name">date</xsl:attribute>
        <xsl:attribute name="content"><xsl:value-of select="daybookindex/metadate" /></xsl:attribute>
    </xsl:element>
    <!-- rel="stylesheet" -->
    <xsl:element name="link">
      <xsl:attribute name="rel">stylesheet</xsl:attribute>
      <xsl:attribute name="type">text/css</xsl:attribute>
      <xsl:attribute name="media">screen,tv</xsl:attribute>
      <xsl:attribute name="href">/css/daybook_index.css</xsl:attribute>
      <xsl:attribute name="title">daybook.css</xsl:attribute>
    </xsl:element>
    <!-- rel="rss" -->
    <xsl:element name="link">
      <xsl:attribute name="rel">alternate</xsl:attribute>
      <xsl:attribute name="type">application/rss+xml</xsl:attribute>
      <xsl:attribute name="title">Update Info:RSS2.0(XML)</xsl:attribute>
      <xsl:attribute name="href">/daybook/dRSS2.xml</xsl:attribute>      
    </xsl:element>
    <!-- title -->
    <xsl:element name="title">Daybook</xsl:element>
  </xsl:element>
</xsl:template>

<!-- ================Templates Navi===================== -->
<xsl:template name="navi">
<xsl:element name="h1">
	<xsl:element name="a"><xsl:attribute name="href">http://www.midore.net</xsl:attribute>www.midore net</xsl:element> ::
  <xsl:element name="a"><xsl:attribute name="href">/daybook/daybook_index.html</xsl:attribute>Daybook Index</xsl:element> ::
  <xsl:element name="a"><xsl:attribute name="href">/daybook/daybook_archives.html</xsl:attribute>Daybook Archives</xsl:element>
</xsl:element>
</xsl:template>


<!-- END -->
</xsl:stylesheet>

