=begin
		dbf.rb
		
		05-11-21
=end

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#		DBFheader
#		wb_擱
#
# C^[tFCX
#		version, date1, date2, date3, numrec, headerbytes, recordbytes, reserve
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class DBFheader
	def initialize
		@version = nil			# o[WȂ
		@date1 = nil				# ŏIXV(Nj
		@date2 = nil				# ŏIXV(j
		@date3 = nil				# ŏIXV(j
		@numrec = nil				# R[h
		@headerbytes = nil	# wb_̃oCg
		@recordbytes = nil	# R[h̃oCg
		@reserve = nil			# \̈Ȃ
	end
	attr_accessor :version, :date1, :date2, :date3, :numrec, :headerbytes, :recordbytes, :reserve
end

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#		DBFfield
#		tB[hvf
#
# C^[tFCX
#		fieldname, fieldtype, fieldsize, decimal, value
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class DBFfield
	def initialize
		@fieldname = ""			#tB[h
		@fieldtype = ""			#tB[h^
		@fieldsize = 0			#tB[h
		@decimal = 0				#tB[h
		@value = nil				#tB[hl
	end
	attr_accessor :fieldname, :fieldtype, :fieldsize, :decimal, :value
end

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#		DBFfields
#		tB[hLqz
#
# C^[tFCX
#		add, fieldname, item, numfields
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class DBFfields
	def initialize
		@fieldarray = []		#tB[hvf̔z
		@fieldhash = {}			#tB[hŃANZX邽߂̃nbVz
	end

#-----------------------------------------------------------------------
#		add
#
#		tB[h`ɁAtB[hzɃtB[hvfǉ
#
# 
#		fnameFtB[h
#		ftypeF^
#		fsizeFtB[h
#		decF
# ߂l
#		Ȃ
#-----------------------------------------------------------------------
	def add(fname, ftype, fsize, dec)
		@field = DBFfield.new
		@field.fieldname = fname
		@field.fieldtype = ftype
		@field.fieldsize = fsize
		@field.decimal = dec

		@fieldarray.push(@field)
		@fieldhash[@field.fieldname] = @fieldarray.size - 1		#tB[hɑΉtB[hԍ擾
	end

#-----------------------------------------------------------------------
#		fieldname
#
# Tv
#		tB[hԍɁAtB[hԂ
#
# 
#		numFtB[hԍ
# ߂l
#		tB[h
#-----------------------------------------------------------------------
	def fieldname(num)
		@fieldarray[num].fieldname
	end

#-----------------------------------------------------------------------
#		item
#		tB[hւ̃ANZX
#
# Tv
#		tB[hɁAtB[hLqz̗vfԂ
#
# 
#		tB[h
# ߂l
#		tB[hvf
#-----------------------------------------------------------------------
	def item(fname)
		@fieldarray[@fieldhash[fname]]
	end

#-----------------------------------------------------------------------
#		numfields
#
# Tv
#		tB[hLqz̗vfԂ
#
# 
#		Ȃ
# ߂l
#		tB[h
#-----------------------------------------------------------------------
	def numfields
		@fieldarray.size
	end
end		# class DBFfields

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#		DBFrecordset
#
# Tv
#		f[^x[Xt@ĆAȉ̂R̕Ȃ
#		P@wb_擱
#		Q@tB[hLq
#		R@f[^R[h
#
# C^[tFCX
#		addfield, dbfopen, close, eof, movefirst, movenext, addnew, update
#		numfields, fieldname, fieldspec, fields
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class DBFrecordset
	def initialize
		@hdlead = DBFheader.new		#wb_擱
		@fields = DBFfields.new		#tB[hLqz

		@dbfeof = FALSE			#EOF
		@dbfbof = FALSE			#BOF
		@headerset = FALSE	# t@CɃwb_܂Ă邩
		@currentrecno = -1	# 0n܂郌R[hԍ
		@numrecords = 0			# 1n܂郌R[h
		@headerlen = 0			# wb_ 
		@recordlen = 0			# R[h
	end

#-----------------------------------------------------------------------
#		addfield
#
# 
#		fnameFtB[h
#		ftypeF^
#		fsizeFtB[h
#		decF
# ߂l
#		Ȃ
#-----------------------------------------------------------------------
	def addfield(fname, ftype, fsize, dec)
		@fields.add(fname, ftype, fsize, dec)
	end

#-----------------------------------------------------------------------
#		dbfopen
#
# Tv
#		Ǎ݃[hł́Awb_ǂݍŃtB[hzɃZbg
#		݃[hł́AI[v邾ŉȂ
#
# 
#		filenameFt@C
#		openmodeFI[v[h "r"=Ǎ݁Ac=VK쐬
# ߂l
#		Ȃ
#-----------------------------------------------------------------------
	def dbfopen(filename, openmode)
		if openmode != "r" and openmode != "c" then
			p "IvṼI[v[h [" + openmode + "] sł"
			exit
		end

		@openmode = openmode
		# ǂݍ݃[h
		if openmode == "r" then
			@fp = open(filename, "rb+")
			if @fp != nil then
				# idbfwb_ǂݍłA܂̂Ƃg߂ǂ͂Ȃj
				#1@wb_擱
				@hdlead.version = @fp.read(1)
				@hdlead.date1 = @fp.read(1)
				@hdlead.date2 = @fp.read(1)
				@hdlead.date3 = @fp.read(1)
				@hdlead.numrec = @fp.read(4)
				@hdlead.headerbytes = @fp.read(2)
				@hdlead.recordbytes = @fp.read(2)
				@hdlead.reserve = @fp.read(20)
				
				@numrecords = @hdlead.numrec.unpack("l").pop 		# - 1
				@headerlen = @hdlead.headerbytes.unpack("s").pop
				@recordlen = @hdlead.recordbytes.unpack("s").pop

				#2@tB[hLq
				numfields = (@hdlead.headerbytes.unpack("s").pop - 1) / 32 - 1
				count = 0
				while count < numfields do
					hdldfieldname = @fp.read(11)	# tB[ȟɋl܂Ă\000Jbg
					hdldfieldtype = @fp.read(1)
					hdldreserve1 = @fp.read(4)
					hdldfieldsize = @fp.read(1)
					hdlddecimal = @fp.read(1)
					hdldreserve2 = @fp.read(14)
					
					@fields.add(hdldfieldname.scan(/^[^\000]+/).pop, hdldfieldtype, hdldfieldsize.unpack("C").pop, hdlddecimal.unpack("C").pop)
					
					count += 1
				end		#while count < numfields do
				@headerset = TRUE		# wb_mF
			else
				p "infile open fail"
			end

		# VK쐬[h
		else
			@fp = open(filename, "wb+")
		end
	end		#def dbfopen(filename, openmode)

#-----------------------------------------------------------------------
#		eof
#-----------------------------------------------------------------------
	def eof
		@dbfeof
	end

#-----------------------------------------------------------------------
#		close
#		VK쐬[h̏ꍇAwb_
#-----------------------------------------------------------------------
	def close
		if @openmode == "c" then
			putheader
			# t@C̏I[}[NiChr(26)A&H1AA&O32j
			@fp.seek(0 + @headerlen + @recordlen * @numrecords, File::SEEK_SET)
			@fp.write("\x1a")
		end
		
		if @fp != nil then
			@fp.close
		end
	end

#-----------------------------------------------------------------------
#		movefirst
#		|C^ŏɃZbgĂPR[hǍ
#
#	t@C̓ǂݏʒúAR[hԍɎw肷
#	t@CI[ɃR[h(&H1A H)邽߁AR[hmĂȂeof𑨂Ȃ
#-----------------------------------------------------------------------
	def movefirst
		if @headerset == FALSE then
			return FALSE
		end
		
		@currentrecno = 0
		moverecord(@currentrecno)
		readrecord
	end

#-----------------------------------------------------------------------
#		movenext
#		R[h|C^Pi߁AR[hǍ
#-----------------------------------------------------------------------
	def movenext
		@currentrecno += 1
		moverecord(@currentrecno)
		if @currentrecno >= @numrecords then
			@currentrecno = @numrecords - 1
		else
			readrecord
		end
	end

#-----------------------------------------------------------------------
#		addnew
#		ǂݏ|C^Ō̃R[ȟɓ
#		̃t@Cɑ΂ŏ̃R[hǉ̏ꍇAwb_łǂݏ|C^Zbg
#-----------------------------------------------------------------------
	def addnew
		if @headerset == FALSE then
			putheader
		end
		@currentrecno = @numrecords
		@fp.seek(0 + @headerlen + @recordlen * @currentrecno, File::SEEK_SET)

		count = 0
		while count < (@fields.numfields) do
			typechar = @fields.item(@fields.fieldname(count)).fieldtype
			if typechar == "N" or typechar == "F" then
				@fields.item(@fields.fieldname(count)).value = 0.0
			elsif typechar == "C" then
				@fields.item(@fields.fieldname(count)).value = ""
			else
				p "illegal type"
			end
			count += 1
		end
	end		# while count < (@fields.numfields) do

#-----------------------------------------------------------------------
#		update
#-----------------------------------------------------------------------
	def update
		writerecord
		
		if @currentrecno == @numrecords then		#   + 1
			@numrecords += 1
		end
	end

#-----------------------------------------------------------------------
#		numfields
#-----------------------------------------------------------------------
	def numfields
		@fields.numfields
	end

#-----------------------------------------------------------------------
#		fieldname
#-----------------------------------------------------------------------
	def fieldname(num)
		@fields.fieldname(num)
	end

#-----------------------------------------------------------------------
#		fieldspec
#		tB[hLqzւ̃C^[tFCX
#		킵AfieldsłȂA炪@fieldsIuWFNgԂ
#		AgȂ
#-----------------------------------------------------------------------
	def fieldspec
		@fields
	end

#-----------------------------------------------------------------------
#		fields
#		tB[hvfւ̃C^[tFCX
#		킵A@fieldIuWFNgԂ̂ł͂ȂAitemԂ
#-----------------------------------------------------------------------
	def fields(fname)
		@fields.item(fname)
	end

#-----------------------------------------------------------------------
#		putheader
#-----------------------------------------------------------------------
	def putheader
		@fp.seek(0, File::SEEK_SET)

		#1@wb_擱
		@fp.write("\003")																			# o[WȂ
		@fp.write([Time.now.strftime("%y").to_i].pack("c"))		# ŏIXV(Nj
		@fp.write([Time.now.strftime("%m").to_i].pack("c"))		# ŏIXV(j
		@fp.write([Time.now.strftime("%d").to_i].pack("c"))		# ŏIXV(j
		@fp.write([@numrecords].pack("l"))										# R[h
		@headerlen = ((@fields.numfields + 1) * 32 + 1)				# wb_̃oCg wb_擱(32oCg){tB[hLq(32oCg) {P  wb_̏I1oCgt
		@fp.write([@headerlen].pack("s"))	

		count = 0
		@recordlen = 1
		while count < (@fields.numfields) do
			@recordlen += @fields.item(@fields.fieldname(count)).fieldsize	
			count += 1
		end
		@fp.write([@recordlen].pack("s"))					# R[h̃oCg ((tB[h)+1) R[h̐擪ɍ폜tB[ht
		@fp.write("\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")		# \̈Ȃ 20oCgo

		#2@tB[hLq
		count = 0
		while count < (@fields.numfields) do
			#tB[h   iDBF t@C̒`ł11oCg)
			fieldnamelen = 0
			fieldnamearr = @fields.fieldname(count).split(//)
			while fieldnamelen < 11 do
				if fieldnamearr.size > 0 then
					@fp.write(fieldnamearr.shift)
				else
					@fp.write("\000")
				end
				fieldnamelen += 1
			end

			@fp.write(@fields.item(@fields.fieldname(count)).fieldtype)			# tB[h^   N,F:l^AC:^
			@fp.write("\000\000\000\000")																		# \̈i4oCgj
			@fp.write([@fields.item(@fields.fieldname(count)).fieldsize.to_i].pack("C"))	# tB[h
			@fp.write([@fields.item(@fields.fieldname(count)).decimal.to_i].pack("C"))		# ̒
			@fp.write("\000\000\000\000\000\000\000\000\000\000\000\000\000\000")					# \̈Ȃǁi14oCgj
			
			count += 1
		end		# while count < (@fields.numfields) do
		
		#2@wb_itB[hLqj̏I}[Ni&H0Dj
		@fp.write("\x0d")
		@headerset = TRUE		# wb_
	end

#-----------------------------------------------------------------------
#		writerecord
#-----------------------------------------------------------------------
	def writerecord
		# 1oCg󔒂óidbft@Cdl̍폜}[Nj
		@fp.write(" ")
		
		count = 0
		while count < (@fields.numfields) do
			typechar = @fields.item(@fields.fieldname(count)).fieldtype
			if typechar == "N" or typechar == "F" then
				# F@fp.printf("%8.3f", value)
				@fp.printf("%" + @fields.item(@fields.fieldname(count)).fieldsize.to_s + "." + @fields.item(@fields.fieldname(count)).decimal.to_s + "f",  @fields.item(@fields.fieldname(count)).value)
			elsif typechar == "C" then
				# F@fp.printf("%-8s", value)
				@fp.printf("%-" + @fields.item(@fields.fieldname(count)).fieldsize.to_s + "s",  @fields.item(@fields.fieldname(count)).value)
			else
				p "illegal type"
			end
			count += 1
		end		# while count < (@fields.numfields) do
	end

#-----------------------------------------------------------------------
#		readrecord
#-----------------------------------------------------------------------
	def readrecord
		# PoCgǂݎ̂Ăidbft@Cdl̍폜}[Nj
		@fp.read(1)
		
		count = 0
		while count < (@fields.numfields) do
			typechar = @fields.item(@fields.fieldname(count)).fieldtype
			if typechar == "N" or  typechar == "F" then
				@fields.item(@fields.fieldname(count)).value = @fp.read(@fields.item(@fields.fieldname(count)).fieldsize).to_f
			elsif typechar == "C" then
				@fields.item(@fields.fieldname(count)).value = @fp.read(@fields.item(@fields.fieldname(count)).fieldsize)
			else
				p "illegal type"
			end
			count += 1
		end		# while count < (@fields.numfields) do
	end

#-----------------------------------------------------------------------
#		moverecord
#		|C^̃R[hԍɃZbg
#
# 
#		recnoFR[hԍ
# ߂l
#		Ȃ
#-----------------------------------------------------------------------
	def moverecord(recno)
		if recno >= @numrecords then
			@dbfeof = TRUE
		elsif recno < 0 then
			@dbfbof = TRUE
		else
			@dbfeof = FALSE
			@dbfbof = FALSE
			# ǂݏ̊JnʒuɃZbg@wb_̍Ō1oCg̃R[h(&H0D)
			# oCgʒu͂On܂BR[hԍ͂On܂B
			@fp.seek(0 + @headerlen + @recordlen * recno, File::SEEK_SET)
		end
	end

#-----------------------------------------------------------------------
#		Ăяo
#-----------------------------------------------------------------------
	protected :putheader, :writerecord, :readrecord, :moverecord

end		# class DBFrecordset
